;disk operations- save+ load
;wifi stahovatko, MB03
;Hood




len_buf	equ buf_len		;=#800	;for MB03+, buffer len has to be always *#400



;temporary
exp_name	ds 10

fnum		dw #55			;file number to be saved/loaded
beg_sec		dw #55			;beginning sector of file (vary when saving/loading)
sec_num		db #55			;number of sectors to save/load
flen_secs	dw #55			;length of file in sectors (enough 2 byte digit??)
disk_buf_len	dw #55			;length of save/load buffer in bytes
buf_len_secs	db #55			;length of save/load buffer in sectors


header
ident		db #B0			;file identification	;#80 when create, #B0 when save done
		ds 4			;time& date		;varaible
ftyp		db #55			;tape header		;variable
fname		ds 10			;file name		;variable
flen		dw #5555		;file length for tape	;variable
fsta		dw #5555
		dw #5555
		dw #5555		;body address
blen		ds 4			;body length
		db #FF			;flagbyte		;always FF when save
		db 0			;attrs			;always 0 when save
		dw 0			;1st sec		;always 0 when save header


;first create file, then initialise variables to save into it
save_file_head	call get_flen_in_scs
		ld a,3
		ld (ftyp),a		;can be also 0 for BASIC, 3 for CODE, 4 for ARRAY, etc.
		ld hl,#8000
		ld (fsta),hl		;file start for CODE, will vary

		ld a,#80
		ld (ident),a
		ld hl,exp_name
		ld de,fname
		ld bc,10
		ldir
		ld ix,header
		ld a,creatx
		call bsdos
		jr nc,disk_error
		ld (fnum),hl		;file with number in HL created
		
		ld hl,0			;prepare beg_sec and sec_num for save/load
		ld (beg_sec),hl
		call count_sec_num
		ret			

;save until file completed, called several times
save_into_file
		ld hl,(fnum)		;save part of file
;		ld ix,RX_buf
		ld ix,basic_end		;ver0.22s
		ld bc,(beg_sec)
		ld a,(sec_num)
		ld e,a
		ld a,savex
		call bsdos
		jr nc,disk_error
		jp next_params		;prepare parameters for next save


;file done,change file ident from #80 to #B0 to become visible
save_close	ld bc,(fnum)
		ld ix,header
		push ix
		push bc
		ld a,getsub
		call bsdos
		jr nc,disk_error
		pop hl
		pop ix
		ld a,#B0
		ld (ident),a
		ld a,owsub
		call bsdos
		ret c
		
disk_error	ld bc,15
d_err		jp error		;NC=disk error, return to main program





load_init	ld bc,(upl_f_num)	;find out, if the file exist
		ld (fnum),bc
		ld a,getsub
		ld ix,header
		call bsdos
		ld bc,25
		jr z,d_err		;file not found
		call get_flen_in_scs
		call count_sec_num	;initialise parameters before loading
		ld hl,0
		ld (beg_sec),hl
		ret

load_file	ld hl,(fnum)
;		ld ix,basic_end
		ld ix,basic_end+#800	;load is loading the file on +#800
		ld bc,(beg_sec)
		ld a,(sec_num)
		ld e,a
		ld a,loa1x
		call bsdos
		jr nc,disk_error
		jr next_params		;prepare paraeters for next load




;auxiliary routines

get_flen_in_scs	ld de,(blen+2)		;find out len of file in secs
		ld hl,(blen)
		ld a,howsec
		call bsdos
		ld (flen_secs),bc
		ret

count_sec_num	ld a,(disk_buf_len+1)	;gives number of sectors to sec_num, either E=len_buf, or flen_secs (if flen_secs< len_buf)
		srl a
		srl a
		ld (buf_len_secs),a
		ld l,a
		ld h,0			;HL=len of buffer in sectors
		ld de,(flen_secs)
		or a
		sbc hl,de
		jr c,csn1		;file length is bigger than buffer
		ld a,e
csn1		ld (sec_num),a
		ret			;...is lower than buffer


next_params	ld d,0			;set parameters for next save/load
		ld a,(buf_len_secs)	;A=length of save/load buffer
		ld e,a
		ld hl,(beg_sec)
		add hl,de		;BC+E	
		ld (beg_sec),hl		;next position of beg_sec
		ld de,(flen_secs)	;DE=length of file in sectors
		ex de,hl
		or a
		sbc hl,de
		inc h
		dec h
		scf			;set carry to signal next save/load is possible
		jr nz,nx_end		;NZ=still file to save/load
		cp l
		jr c,nx_end		;C= still we can save/load	
					;NC= will be the last save/load
		ld a,l			
nx_end		ld (sec_num),a		;last set of sec_num
		ret
		
sub32		equ #B
howsec		equ #F
getsub		equ #16
owsub		equ #1B
loa1x		equ #22
savex		equ #25
creatx		equ #26
bsdos		call #3C9E
		rst #20
		call #3C98
		ret

;		ds #20			;place for application SP
end
len=end-start